Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.imageio.stream
Class ImageInputStreamImpl

    java.lang.Object
      javax.imageio.stream.ImageInputStreamImpl

All Implemented Interfaces:
  DataInput, ImageInputStream

Direct Known Subclasses:
  FileCacheImageInputStream, FileImageInputStream, ImageOutputStreamImpl, MemoryCacheImageInputStream

    public abstract class ImageInputStreamImpl

extends Object
implements ImageInputStream

An abstract class implementing the `ImageInputStream` interface. This class is designed to reduce the number of methods that must be implemented by subclasses.

In particular, this class handles most or all of the details of byte order interpretation, buffering, mark/reset, discarding, closing, and disposing.

Field Summary
`protected int` | `bitOffset` The current bit offset within the stream.
`protected ByteOrder` | `byteOrder` The byte order of the stream as an instance of the enumeration class `java.nio.ByteOrder`, where `ByteOrder.BIG_ENDIAN` indicates network byte order and `ByteOrder.LITTLE_ENDIAN` indicates the reverse order.
`protected long` | `flushedPos` The position prior to which data may be discarded.
`protected long` | `streamPos` The current read position within the stream.

Constructor Summary
`ImageInputStreamImpl()` Constructs an `ImageInputStreamImpl`.

Method Summary
`protected void` | `checkClosed()` Throws an `IOException` if the stream has been closed.
`void` | `close()` Closes the stream.
`protected void` | `finalize()` Finalizes this object prior to garbage collection.
`void` | `flush()` Discards the initial position of the stream prior to the current stream position.
`void` | `flushBefore(long pos)` Discards the initial portion of the stream prior to the indicated postion.
`int` | `getBitOffset()` Returns the current bit offset, as an integer between 0 and 7, inclusive.
`ByteOrder` | `getByteOrder()` Returns the byte order with which data values will be read from this stream as an instance of the `java.nio.ByteOrder` enumeration.
`long` | `getFlushedPosition()` Returns the earliest position in the stream to which seeking may be performed.
`long` | `getStreamPosition()` Returns the current byte position of the stream.
`boolean` | `isCached()` Default implementation returns false.
`boolean` | `isCachedFile()` Default implementation returns false.
`boolean` | `isCachedMemory()` Default implementation returns false.
`long` | `length()` Returns `-1L` to indicate that the stream has unknown length.
`void` | `mark()` Pushes the current stream position onto a stack of marked positions.
`abstract int` | `read()` Reads a single byte from the stream and returns it as an integer between 0 and 255.
`int` | `read(byte[] b)` A convenience method that calls `read(b, 0, b.length)`.
`abstract int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes from the stream, and stores them into `b` starting at index `off`.
`int` | `readBit()` Reads a single bit from the stream and returns it as an `int` with the value `0` or `1`.
`long` | `readBits(int numBits)` Reads a bitstring from the stream and returns it as a `long`, with the first bit read becoming the most significant bit of the output.
`boolean` | `readBoolean()` Reads one input byte and returns `true` if that byte is nonzero, `false` if that byte is zero.
`byte` | `readByte()` Reads and returns one input byte.
`void` | `readBytes(IIOByteBuffer buf, int len)` Reads up to `len` bytes from the stream, and modifies the supplied `IIOByteBuffer` to indicate the byte array, offset, and length where the data may be found.
`char` | `readChar()` Reads an input `char` and returns the `char` value.
`double` | `readDouble()` Reads eight input bytes and returns a `double` value.
`float` | `readFloat()` Reads four input bytes and returns a `float` value.
`void` | `readFully(byte[] b)` Reads some bytes from an input stream and stores them into the buffer array `b`.
`void` | `readFully(byte[] b, int off, int len)` Reads `len` bytes from an input stream.
`void` | `readFully(char[] c, int off, int len)` Reads `len` chars (unsigned 16-bit integers) from the stream according to the current byte order, and stores them into `c` starting at index `off`.
`void` | `readFully(double[] d, int off, int len)` Reads `len` doubles (64-bit IEEE double-precision floats) from the stream according to the current byte order, and stores them into `d` starting at index `off`.
`void` | `readFully(float[] f, int off, int len)` Reads `len` floats (32-bit IEEE single-precision floats) from the stream according to the current byte order, and stores them into `f` starting at index `off`.
`void` | `readFully(int[] i, int off, int len)` Reads `len` ints (signed 32-bit integers) from the stream according to the current byte order, and stores them into `i` starting at index `off`.
`void` | `readFully(long[] l, int off, int len)` Reads `len` longs (signed 64-bit integers) from the stream according to the current byte order, and stores them into `l` starting at index `off`.
`void` | `readFully(short[] s, int off, int len)` Reads `len` shorts (signed 16-bit integers) from the stream according to the current byte order, and stores them into `s` starting at index `off`.
`int` | `readInt()` Reads four input bytes and returns an `int` value.
`String` | `readLine()` Reads the next line of text from the input stream.
`long` | `readLong()` Reads eight input bytes and returns a `long` value.
`short` | `readShort()` Reads two input bytes and returns a `short` value.
`int` | `readUnsignedByte()` Reads one input byte, zero-extends it to type `int`, and returns the result, which is therefore in the range `0` through `255`.
`long` | `readUnsignedInt()` Reads 4 bytes from the stream, and (conceptually) concatenates them according to the current byte order, converts the result to a long, masks it with `0xffffffffL` in order to strip off any sign-extension bits, and returns the result as an unsigned `long` value.
`int` | `readUnsignedShort()` Reads two input bytes and returns an `int` value in the range `0` through `65535`.
`String` | `readUTF()` Reads in a string that has been encoded using a modified UTF-8 format.
`void` | `reset()` Resets the current stream byte and bit positions from the stack of marked positions.
`void` | `seek(long pos)` Sets the current stream position to the desired location.
`void` | `setBitOffset(int bitOffset)` Sets the bit offset to an integer between 0 and 7, inclusive.
`void` | `setByteOrder(ByteOrder byteOrder)` Sets the desired byte order for future reads of data values from this stream.
`int` | `skipBytes(int n)` Advances the current stream position by calling `seek(getStreamPosition() + n)`.
`long` | `skipBytes(long n)` Advances the current stream position by calling `seek(getStreamPosition() + n)`.

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### byteOrder

    protected ByteOrder byteOrder

  The byte order of the stream as an instance of the enumeration class `java.nio.ByteOrder`, where `ByteOrder.BIG_ENDIAN` indicates network byte order and `ByteOrder.LITTLE_ENDIAN` indicates the reverse order. By default, the value is `ByteOrder.BIG_ENDIAN`.

### streamPos

    protected long streamPos

  The current read position within the stream. Subclasses are responsible for keeping this value current from any method they override that alters the read position.

### bitOffset

    protected int bitOffset

  The current bit offset within the stream. Subclasses are responsible for keeping this value current from any method they override that alters the bit offset.

### flushedPos

    protected long flushedPos

  The position prior to which data may be discarded. Seeking to a smaller position is not allowed. `flushedPos` will always be >= 0.

Constructor Detail

### ImageInputStreamImpl

    public ImageInputStreamImpl()

  Constructs an `ImageInputStreamImpl`.

Method Detail

### checkClosed

    protected final void checkClosed()
                              throws IOException

  Throws an `IOException` if the stream has been closed. Subclasses may call this method from any of their methods that require the stream not to be closed.

  Throws:
    `IOException` - if the stream is closed.

### setByteOrder

    public void setByteOrder(ByteOrder byteOrder)

  Description copied from interface: `ImageInputStream`
  Sets the desired byte order for future reads of data values from this stream. For example, the sequence of bytes '0x01 0x02 0x03 0x04' if read as a 4-byte integer would have the value '0x01020304' using network byte order and the value '0x04030201' under the reverse byte order.

  The enumeration class `java.nio.ByteOrder` is used to specify the byte order. A value of `ByteOrder.BIG_ENDIAN` specifies so-called big-endian or network byte order, in which the high-order byte comes first. Motorola and Sparc processors store data in this format, while Intel processors store data in the reverse `ByteOrder.LITTLE_ENDIAN` order.

  The byte order has no effect on the results returned from the `readBits` method (or the value written by `ImageOutputStream.writeBits`).

  Specified by:
    `setByteOrder` in interface `ImageInputStream`
  Parameters:
    `byteOrder` - one of `ByteOrder.BIG_ENDIAN` or `java.nio.ByteOrder.LITTLE_ENDIAN`, indicating whether network byte order or its reverse will be used for future reads.
  See Also:
    `ByteOrder`, `ImageInputStream.getByteOrder()`, `ImageInputStream.readBits(int)`

### getByteOrder

    public ByteOrder getByteOrder()

  Description copied from interface: `ImageInputStream`
  Returns the byte order with which data values will be read from this stream as an instance of the `java.nio.ByteOrder` enumeration.

  Specified by:
    `getByteOrder` in interface `ImageInputStream`
  Returns:
    one of `ByteOrder.BIG_ENDIAN` or `ByteOrder.LITTLE_ENDIAN`, indicating which byte order is being used.
  See Also:
    `ByteOrder`, `ImageInputStream.setByteOrder(java.nio.ByteOrder)`

### read

    public abstract int read()
                      throws IOException

  Description copied from interface: `ImageInputStream`
  Reads a single byte from the stream and returns it as an integer between 0 and 255. If the end of the stream is reached, -1 is returned.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `read` in interface `ImageInputStream`
  Returns:
    a byte value from the stream, as an int, or -1 to indicate EOF.
  Throws:
    `IOException` - if an I/O error occurs.

### read

    public int read(byte[] b)
             throws IOException

  A convenience method that calls `read(b, 0, b.length)`.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `read` in interface `ImageInputStream`
  Parameters:
    `b` - an array of bytes to be written to.
  Returns:
    the number of bytes actually read, or `-1` to indicate EOF.
  Throws:
    `NullPointerException` - if `b` is `null`.
    `IOException` - if an I/O error occurs.

### read

    public abstract int read(byte[] b,
                             int off,
                             int len)
                      throws IOException

  Reads up to `len` bytes from the stream, and stores them into `b` starting at index `off`. If no bytes can be read because the end of the stream has been reached, `-1` is returned.

  The bit offset within the stream must be reset to zero before the read occurs.

  Subclasses must provide an implementation for this method. The subclass implementation should update the stream position before exiting.

  Specified by:
    `read` in interface `ImageInputStream`
  Parameters:
    `b` - an array of bytes to be written to.
    `off` - the starting position within `b` to write to.
    `len` - the maximum number of bytes to read.
  Returns:
    the number of bytes actually read, or `-1` to indicate EOF.
  Throws:
    `IndexOutOfBoundsException` - if `off` is negative, `len` is negative, or `off + len` is greater than `b.length`.
    `NullPointerException` - if `b` is `null`.
    `IOException` - if an I/O error occurs.

### readBytes

    public void readBytes(IIOByteBuffer buf,
                          int len)
                   throws IOException

  Description copied from interface: `ImageInputStream`
  Reads up to `len` bytes from the stream, and modifies the supplied `IIOByteBuffer` to indicate the byte array, offset, and length where the data may be found. The caller should not attempt to modify the data found in the `IIOByteBuffer`.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `readBytes` in interface `ImageInputStream`
  Parameters:
    `buf` - an IIOByteBuffer object to be modified.
    `len` - the maximum number of `byte`s to read.
  Throws:
    `IOException` - if an I/O error occurs.

### readBoolean

    public boolean readBoolean()
                        throws IOException

  Description copied from interface: `DataInput`
  Reads one input byte and returns `true` if that byte is nonzero, `false` if that byte is zero. This method is suitable for reading the byte written by the `writeBoolean` method of interface `DataOutput`.

  Specified by:
    `readBoolean` in interface `DataInput`
  Specified by:
    `readBoolean` in interface `ImageInputStream`
  Returns:
    the `boolean` value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readByte

    public byte readByte()
                  throws IOException

  Description copied from interface: `DataInput`
  Reads and returns one input byte. The byte is treated as a signed value in the range `-128` through `127`, inclusive. This method is suitable for reading the byte written by the `writeByte` method of interface `DataOutput`.

  Specified by:
    `readByte` in interface `DataInput`
  Specified by:
    `readByte` in interface `ImageInputStream`
  Returns:
    the 8-bit value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readUnsignedByte

    public int readUnsignedByte()
                         throws IOException

  Description copied from interface: `DataInput`
  Reads one input byte, zero-extends it to type `int`, and returns the result, which is therefore in the range `0` through `255`. This method is suitable for reading the byte written by the `writeByte` method of interface `DataOutput` if the argument to `writeByte` was intended to be a value in the range `0` through `255`.

  Specified by:
    `readUnsignedByte` in interface `DataInput`
  Specified by:
    `readUnsignedByte` in interface `ImageInputStream`
  Returns:
    the unsigned 8-bit value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readShort

    public short readShort()
                    throws IOException

  Description copied from interface: `DataInput`
  Reads two input bytes and returns a `short` value. Let `a` be the first byte read and `b` be the second byte. The value returned is:

      (short)((a << 8) | (b & 0xff))

  This method is suitable for reading the bytes written by the `writeShort` method of interface `DataOutput`.

  Specified by:
    `readShort` in interface `DataInput`
  Specified by:
    `readShort` in interface `ImageInputStream`
  Returns:
    the 16-bit value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.getByteOrder()`

### readUnsignedShort

    public int readUnsignedShort()
                          throws IOException

  Description copied from interface: `DataInput`
  Reads two input bytes and returns an `int` value in the range `0` through `65535`. Let `a` be the first byte read and `b` be the second byte. The value returned is:

      (((a & 0xff) << 8) | (b & 0xff))

  This method is suitable for reading the bytes written by the `writeShort` method of interface `DataOutput` if the argument to `writeShort` was intended to be a value in the range `0` through `65535`.

  Specified by:
    `readUnsignedShort` in interface `DataInput`
  Specified by:
    `readUnsignedShort` in interface `ImageInputStream`
  Returns:
    the unsigned 16-bit value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.getByteOrder()`

### readChar

    public char readChar()
                  throws IOException

  Description copied from interface: `DataInput`
  Reads an input `char` and returns the `char` value. A Unicode `char` is made up of two bytes. Let `a` be the first byte read and `b` be the second byte. The value returned is:

      (char)((a << 8) | (b & 0xff))

  This method is suitable for reading bytes written by the `writeChar` method of interface `DataOutput`.

  Specified by:
    `readChar` in interface `DataInput`
  Specified by:
    `readChar` in interface `ImageInputStream`
  Returns:
    the Unicode `char` read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.readUnsignedShort()`

### readInt

    public int readInt()
                throws IOException

  Description copied from interface: `DataInput`
  Reads four input bytes and returns an `int` value. Let `a` be the first byte read, `b` be the second byte, `c` be the third byte, and `d` be the fourth byte. The value returned is:

       (((a & 0xff) << 24) | ((b & 0xff) << 16) |
        ((c & 0xff) << 8) | (d & 0xff))

  This method is suitable for reading bytes written by the `writeInt` method of interface `DataOutput`.

  Specified by:
    `readInt` in interface `DataInput`
  Specified by:
    `readInt` in interface `ImageInputStream`
  Returns:
    the `int` value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.getByteOrder()`

### readUnsignedInt

    public long readUnsignedInt()
                         throws IOException

  Description copied from interface: `ImageInputStream`
  Reads 4 bytes from the stream, and (conceptually) concatenates them according to the current byte order, converts the result to a long, masks it with `0xffffffffL` in order to strip off any sign-extension bits, and returns the result as an unsigned `long` value.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `readUnsignedInt` in interface `ImageInputStream`
  Returns:
    an unsigned int value from the stream, as a long.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.getByteOrder()`

### readLong

    public long readLong()
                  throws IOException

  Description copied from interface: `DataInput`
  Reads eight input bytes and returns a `long` value. Let `a` be the first byte read, `b` be the second byte, `c` be the third byte, `d` be the fourth byte, `e` be the fifth byte, `f` be the sixth byte, `g` be the seventh byte, and `h` be the eighth byte. The value returned is:

       (((long)(a & 0xff) << 56) |
        ((long)(b & 0xff) << 48) |
        ((long)(c & 0xff) << 40) |
        ((long)(d & 0xff) << 32) |
        ((long)(e & 0xff) << 24) |
        ((long)(f & 0xff) << 16) |
        ((long)(g & 0xff) <<  8) |
        ((long)(h & 0xff)))

  This method is suitable for reading bytes written by the `writeLong` method of interface `DataOutput`.

  Specified by:
    `readLong` in interface `DataInput`
  Specified by:
    `readLong` in interface `ImageInputStream`
  Returns:
    the `long` value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.getByteOrder()`

### readFloat

    public float readFloat()
                    throws IOException

  Description copied from interface: `DataInput`
  Reads four input bytes and returns a `float` value. It does this by first constructing an `int` value in exactly the manner of the `readInt` method, then converting this `int` value to a `float` in exactly the manner of the method `Float.intBitsToFloat`. This method is suitable for reading bytes written by the `writeFloat` method of interface `DataOutput`.

  Specified by:
    `readFloat` in interface `DataInput`
  Specified by:
    `readFloat` in interface `ImageInputStream`
  Returns:
    the `float` value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.getByteOrder()`

### readDouble

    public double readDouble()
                      throws IOException

  Description copied from interface: `DataInput`
  Reads eight input bytes and returns a `double` value. It does this by first constructing a `long` value in exactly the manner of the `readlong` method, then converting this `long` value to a `double` in exactly the manner of the method `Double.longBitsToDouble`. This method is suitable for reading bytes written by the `writeDouble` method of interface `DataOutput`.

  Specified by:
    `readDouble` in interface `DataInput`
  Specified by:
    `readDouble` in interface `ImageInputStream`
  Returns:
    the `double` value read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.getByteOrder()`

### readLine

    public String readLine()
                    throws IOException

  Description copied from interface: `DataInput`
  Reads the next line of text from the input stream. It reads successive bytes, converting each byte separately into a character, until it encounters a line terminator or end of file; the characters read are then returned as a `String`. Note that because this method processes bytes, it does not support input of the full Unicode character set.

  If end of file is encountered before even one byte can be read, then `null` is returned. Otherwise, each byte that is read is converted to type `char` by zero-extension. If the character `'\n'` is encountered, it is discarded and reading ceases. If the character `'\r'` is encountered, it is discarded and, if the following byte converts to the character `'\n'`, then that is discarded also; reading then ceases. If end of file is encountered before either of the characters `'\n'` and `'\r'` is encountered, reading ceases. Once reading has ceased, a `String` is returned that contains all the characters read and not discarded, taken in order. Note that every character in this string will have a value less than `\u0100`, that is, `(char)256`.

  Specified by:
    `readLine` in interface `DataInput`
  Specified by:
    `readLine` in interface `ImageInputStream`
  Returns:
    the next line of text from the input stream, or `null` if the end of file is encountered before a byte can be read.
  Throws:
    `IOException` - if an I/O error occurs.

### readUTF

    public String readUTF()
                   throws IOException

  Description copied from interface: `DataInput`
  Reads in a string that has been encoded using a modified UTF-8 format. The general contract of `readUTF` is that it reads a representation of a Unicode character string encoded in modified UTF-8 format; this string of characters is then returned as a `String`.

  First, two bytes are read and used to construct an unsigned 16-bit integer in exactly the manner of the `readUnsignedShort` method . This integer value is called the UTF length and specifies the number of additional bytes to be read. These bytes are then converted to characters by considering them in groups. The length of each group is computed from the value of the first byte of the group. The byte following a group, if any, is the first byte of the next group.

  If the first byte of a group matches the bit pattern `0xxxxxxx` (where `x` means "may be `0` or `1`"), then the group consists of just that byte. The byte is zero-extended to form a character.

  If the first byte of a group matches the bit pattern `110xxxxx`, then the group consists of that byte `a` and a second byte `b`. If there is no byte `b` (because byte `a` was the last of the bytes to be read), or if byte `b` does not match the bit pattern `10xxxxxx`, then a `UTFDataFormatException` is thrown. Otherwise, the group is converted to the character:

      (char)(((a& 0x1F) << 6) | (b & 0x3F))

  If the first byte of a group matches the bit pattern `1110xxxx`, then the group consists of that byte `a` and two more bytes `b` and `c`. If there is no byte `c` (because byte `a` was one of the last two of the bytes to be read), or either byte `b` or byte `c` does not match the bit pattern `10xxxxxx`, then a `UTFDataFormatException` is thrown. Otherwise, the group is converted to the character:

       (char)(((a & 0x0F) << 12) | ((b & 0x3F) << 6) | (c & 0x3F))

  If the first byte of a group matches the pattern `1111xxxx` or the pattern `10xxxxxx`, then a `UTFDataFormatException` is thrown.

  If end of file is encountered at any time during this entire process, then an `EOFException` is thrown.

  After every group has been converted to a character by this process, the characters are gathered, in the same order in which their corresponding groups were read from the input stream, to form a `String`, which is returned.

  The `writeUTF` method of interface `DataOutput` may be used to write data that is suitable for reading by this method.

  Specified by:
    `readUTF` in interface `DataInput`
  Specified by:
    `readUTF` in interface `ImageInputStream`
  Returns:
    a Unicode string.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.
    `UTFDataFormatException` - if the bytes do not represent a valid modified UTF-8 encoding of a string.

### readFully

    public void readFully(byte[] b,
                          int off,
                          int len)
                   throws IOException

  Description copied from interface: `DataInput`
  Reads `len` bytes from an input stream.

  This method blocks until one of the following conditions occurs:

  - `len` bytes of input data are available, in which case a normal return is made.
  - End of file is detected, in which case an `EOFException` is thrown.
  - An I/O error occurs, in which case an `IOException` other than `EOFException` is thrown.

  If `b` is `null`, a `NullPointerException` is thrown. If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown. If `len` is zero, then no bytes are read. Otherwise, the first byte read is stored into element `b[off]`, the next one into `b[off+1]`, and so on. The number of bytes read is, at most, equal to `len`.

  Specified by:
    `readFully` in interface `DataInput`
  Specified by:
    `readFully` in interface `ImageInputStream`
  Parameters:
    `b` - the buffer into which the data is read.
    `off` - an int specifying the offset into the data.
    `len` - an int specifying the number of bytes to read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readFully

    public void readFully(byte[] b)
                   throws IOException

  Description copied from interface: `DataInput`
  Reads some bytes from an input stream and stores them into the buffer array `b`. The number of bytes read is equal to the length of `b`.

  This method blocks until one of the following conditions occurs:

  - `b.length` bytes of input data are available, in which case a normal return is made.
  - End of file is detected, in which case an `EOFException` is thrown.
  - An I/O error occurs, in which case an `IOException` other than `EOFException` is thrown.

  If `b` is `null`, a `NullPointerException` is thrown. If `b.length` is zero, then no bytes are read. Otherwise, the first byte read is stored into element `b[0]`, the next one into `b[1]`, and so on. If an exception is thrown from this method, then it may be that some but not all bytes of `b` have been updated with data from the input stream.

  Specified by:
    `readFully` in interface `DataInput`
  Specified by:
    `readFully` in interface `ImageInputStream`
  Parameters:
    `b` - the buffer into which the data is read.
  Throws:
    `EOFException` - if this stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readFully

    public void readFully(short[] s,
                          int off,
                          int len)
                   throws IOException

  Description copied from interface: `ImageInputStream`
  Reads `len` shorts (signed 16-bit integers) from the stream according to the current byte order, and stores them into `s` starting at index `off`. If the end of the stream is reached, an `EOFException` will be thrown.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `readFully` in interface `ImageInputStream`
  Parameters:
    `s` - an array of shorts to be written to.
    `off` - the starting position withinb to write to.
    `len` - the maximum number of `short`s to read.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readFully

    public void readFully(char[] c,
                          int off,
                          int len)
                   throws IOException

  Description copied from interface: `ImageInputStream`
  Reads `len` chars (unsigned 16-bit integers) from the stream according to the current byte order, and stores them into `c` starting at index `off`. If the end of the stream is reached, an `EOFException` will be thrown.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `readFully` in interface `ImageInputStream`
  Parameters:
    `c` - an array of chars to be written to.
    `off` - the starting position withinb to write to.
    `len` - the maximum number of `char`s to read.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readFully

    public void readFully(int[] i,
                          int off,
                          int len)
                   throws IOException

  Description copied from interface: `ImageInputStream`
  Reads `len` ints (signed 32-bit integers) from the stream according to the current byte order, and stores them into `i` starting at index `off`. If the end of the stream is reached, an `EOFException` will be thrown.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `readFully` in interface `ImageInputStream`
  Parameters:
    `i` - an array of ints to be written to.
    `off` - the starting position withinb to write to.
    `len` - the maximum number of `int`s to read.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readFully

    public void readFully(long[] l,
                          int off,
                          int len)
                   throws IOException

  Description copied from interface: `ImageInputStream`
  Reads `len` longs (signed 64-bit integers) from the stream according to the current byte order, and stores them into `l` starting at index `off`. If the end of the stream is reached, an `EOFException` will be thrown.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `readFully` in interface `ImageInputStream`
  Parameters:
    `l` - an array of longs to be written to.
    `off` - the starting position withinb to write to.
    `len` - the maximum number of `long`s to read.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readFully

    public void readFully(float[] f,
                          int off,
                          int len)
                   throws IOException

  Description copied from interface: `ImageInputStream`
  Reads `len` floats (32-bit IEEE single-precision floats) from the stream according to the current byte order, and stores them into `f` starting at index `off`. If the end of the stream is reached, an `EOFException` will be thrown.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `readFully` in interface `ImageInputStream`
  Parameters:
    `f` - an array of floats to be written to.
    `off` - the starting position withinb to write to.
    `len` - the maximum number of `float`s to read.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### readFully

    public void readFully(double[] d,
                          int off,
                          int len)
                   throws IOException

  Description copied from interface: `ImageInputStream`
  Reads `len` doubles (64-bit IEEE double-precision floats) from the stream according to the current byte order, and stores them into `d` starting at index `off`. If the end of the stream is reached, an `EOFException` will be thrown.

  The bit offset within the stream is reset to zero before the read occurs.

  Specified by:
    `readFully` in interface `ImageInputStream`
  Parameters:
    `d` - an array of doubles to be written to.
    `off` - the starting position withinb to write to.
    `len` - the maximum number of `double`s to read.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bytes.
    `IOException` - if an I/O error occurs.

### getStreamPosition

    public long getStreamPosition()
                           throws IOException

  Description copied from interface: `ImageInputStream`
  Returns the current byte position of the stream. The next read will take place starting at this offset.

  Specified by:
    `getStreamPosition` in interface `ImageInputStream`
  Returns:
    a long containing the position of the stream.
  Throws:
    `IOException` - if an I/O error occurs.

### getBitOffset

    public int getBitOffset()
                     throws IOException

  Description copied from interface: `ImageInputStream`
  Returns the current bit offset, as an integer between 0 and 7, inclusive. The bit offset is updated implicitly by calls to the `readBits` method. A value of 0 indicates the most-significant bit, and a value of 7 indicates the least significant bit, of the byte being read.

  The bit offset is set to 0 when a stream is first opened, and is reset to 0 by calls to `seek`, `skipBytes`, or any `read` or `readFully` method.

  Specified by:
    `getBitOffset` in interface `ImageInputStream`
  Returns:
    an `int` containing the bit offset between 0 and 7, inclusive.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.setBitOffset(int)`

### setBitOffset

    public void setBitOffset(int bitOffset)
                      throws IOException

  Description copied from interface: `ImageInputStream`
  Sets the bit offset to an integer between 0 and 7, inclusive. The byte offset within the stream, as returned by `getStreamPosition`, is left unchanged. A value of 0 indicates the most-significant bit, and a value of 7 indicates the least significant bit, of the byte being read.

  Specified by:
    `setBitOffset` in interface `ImageInputStream`
  Parameters:
    `bitOffset` - the desired offset, as an `int` between 0 and 7, inclusive.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageInputStream.getBitOffset()`

### readBit

    public int readBit()
                throws IOException

  Description copied from interface: `ImageInputStream`
  Reads a single bit from the stream and returns it as an `int` with the value `0` or `1`. The bit offset is advanced by one and reduced modulo 8.

  Specified by:
    `readBit` in interface `ImageInputStream`
  Returns:
    an `int` containing the value `0` or `1`.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bits.
    `IOException` - if an I/O error occurs.

### readBits

    public long readBits(int numBits)
                  throws IOException

  Description copied from interface: `ImageInputStream`
  Reads a bitstring from the stream and returns it as a `long`, with the first bit read becoming the most significant bit of the output. The read starts within the byte indicated by `getStreamPosition`, at the bit given by `getBitOffset`. The bit offset is advanced by `numBits` and reduced modulo 8.

  The byte order of the stream has no effect on this method. The return value of this method is constructed as though the bits were read one at a time, and shifted into the right side of the return value, as shown by the following pseudo-code:

       long accum = 0L;
       for (int i = 0; i < numBits; i++) {
         accum <<= 1; // Shift left one bit to make room
         accum |= readBit();
       }

  Note that the result of `readBits(32)` may thus not be equal to that of `readInt()` if a reverse network byte order is being used (i.e., `getByteOrder() == false`).

  If the end of the stream is encountered before all the bits have been read, an `EOFException` is thrown.

  Specified by:
    `readBits` in interface `ImageInputStream`
  Parameters:
    `numBits` - the number of bits to read, as an `int` between 0 and 64, inclusive.
  Returns:
    the bitstring, as a `long` with the last bit read stored in the least significant bit.
  Throws:
    `EOFException` - if the stream reaches the end before reading all the bits.
    `IOException` - if an I/O error occurs.

### length

    public long length()

  Returns `-1L` to indicate that the stream has unknown length. Subclasses must override this method to provide actual length information.

  Specified by:
    `length` in interface `ImageInputStream`
  Returns:
    -1L to indicate unknown length.

### skipBytes

    public int skipBytes(int n)
                  throws IOException

  Advances the current stream position by calling `seek(getStreamPosition() + n)`.

  The bit offset is reset to zero.

  Specified by:
    `skipBytes` in interface `DataInput`
  Specified by:
    `skipBytes` in interface `ImageInputStream`
  Parameters:
    `n` - the number of bytes to seek forward.
  Returns:
    an `int` representing the number of bytes skipped.
  Throws:
    `IOException` - if `getStreamPosition` throws an `IOException` when computing either the starting or ending position.

### skipBytes

    public long skipBytes(long n)
                   throws IOException

  Advances the current stream position by calling `seek(getStreamPosition() + n)`.

  The bit offset is reset to zero.

  Specified by:
    `skipBytes` in interface `ImageInputStream`
  Parameters:
    `n` - the number of bytes to seek forward.
  Returns:
    a `long` representing the number of bytes skipped.
  Throws:
    `IOException` - if `getStreamPosition` throws an `IOException` when computing either the starting or ending position.

### seek

    public void seek(long pos)
              throws IOException

  Description copied from interface: `ImageInputStream`
  Sets the current stream position to the desired location. The next read will occur at this location. The bit offset is set to 0.

  An `IndexOutOfBoundsException` will be thrown if `pos` is smaller than the flushed position (as returned by `getflushedPosition`).

  It is legal to seek past the end of the file; an `EOFException` will be thrown only if a read is performed.

  Specified by:
    `seek` in interface `ImageInputStream`
  Parameters:
    `pos` - a `long` containing the desired file pointer position.
  Throws:
    `IOException` - if any other I/O error occurs.

### mark

    public void mark()

  Pushes the current stream position onto a stack of marked positions.

  Specified by:
    `mark` in interface `ImageInputStream`

### reset

    public void reset()
               throws IOException

  Resets the current stream byte and bit positions from the stack of marked positions.

  An `IOException` will be thrown if the previous marked position lies in the discarded portion of the stream.

  Specified by:
    `reset` in interface `ImageInputStream`
  Throws:
    `IOException` - if an I/O error occurs.

### flushBefore

    public void flushBefore(long pos)
                     throws IOException

  Description copied from interface: `ImageInputStream`
  Discards the initial portion of the stream prior to the indicated postion. Attempting to seek to an offset within the flushed portion of the stream will result in an `IndexOutOfBoundsException`.

  Calling `flushBefore` may allow classes implementing this interface to free up resources such as memory or disk space that are being used to store data from the stream.

  Specified by:
    `flushBefore` in interface `ImageInputStream`
  Parameters:
    `pos` - a `long` containing the length of the file prefix that may be flushed.
  Throws:
    `IOException` - if an I/O error occurs.

### flush

    public void flush()
               throws IOException

  Description copied from interface: `ImageInputStream`
  Discards the initial position of the stream prior to the current stream position. Equivalent to `flushBefore(getStreamPosition())`.

  Specified by:
    `flush` in interface `ImageInputStream`
  Throws:
    `IOException` - if an I/O error occurs.

### getFlushedPosition

    public long getFlushedPosition()

  Description copied from interface: `ImageInputStream`
  Returns the earliest position in the stream to which seeking may be performed. The returned value will be the maximum of all values passed into previous calls to `flushBefore`.

  Specified by:
    `getFlushedPosition` in interface `ImageInputStream`
  Returns:
    the earliest legal position for seeking, as a `long`.

### isCached

    public boolean isCached()

  Default implementation returns false. Subclasses should override this if they cache data.

  Specified by:
    `isCached` in interface `ImageInputStream`
  Returns:
    `true` if this `ImageInputStream` caches data.
  See Also:
    `ImageInputStream.isCachedMemory()`, `ImageInputStream.isCachedFile()`

### isCachedMemory

    public boolean isCachedMemory()

  Default implementation returns false. Subclasses should override this if they cache data in main memory.

  Specified by:
    `isCachedMemory` in interface `ImageInputStream`
  Returns:
    `true` if this `ImageInputStream` caches data in main memory.
  See Also:
    `ImageInputStream.isCached()`, `ImageInputStream.isCachedFile()`

### isCachedFile

    public boolean isCachedFile()

  Default implementation returns false. Subclasses should override this if they cache data in a temporary file.

  Specified by:
    `isCachedFile` in interface `ImageInputStream`
  Returns:
    `true` if this `ImageInputStream` caches data in a temporary file.
  See Also:
    `ImageInputStream.isCached()`, `ImageInputStream.isCachedMemory()`

### close

    public void close()
               throws IOException

  Description copied from interface: `ImageInputStream`
  Closes the stream. Attempts to access a stream that has been closed may result in `IOException`s or incorrect behavior. Calling this method may allow classes implementing this interface to release resources associated with the stream such as memory, disk space, or file descriptors.

  Specified by:
    `close` in interface `ImageInputStream`
  Throws:
    `IOException` - if an I/O error occurs.

### finalize

    protected void finalize()
                     throws Throwable

  Finalizes this object prior to garbage collection. The `close` method is called to close any open input source. This method should not be called from application code.

  Overrides:
    `finalize` in class `Object`
  Throws:
    `Throwable` - if an error occurs during superclass finalization.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.